the Ini Manager Form

Ini Manager

Optimized for managing SelectCAD civil.ini's, Ini Manager provides the ability to

  • segregate file operations by SelectCAD function
  • filter operations by Preference "themes" or groups
  • filter Preference themes by keyword or pattern
  • export to file, filtered by Preference "themes" or groups"
  • resize text heights, widths, and/or linespacing globally or by filter
  • sort definitions alphabetically by Header
  • identify differences between two files
  • append definitions from one file to another (excellent for building libraries of Feature Filters, etc.) and
  • globally or selectively Overwrite (Clobber) deviant settings definitions

For up to date information on Ini Manager, visit http://civilxlr8.com

Note: for safety Ini Manger does not write directly to files. Results are displayed in a window from which they can be written to a file.

The Ini Manager Main Form is divided into three sections:

  • The Input Frame, where a Source file and Header types are selected,

  • The Filter Frame, where data can be filtered by keyword, and

  • The Action Tabs, where actions can be performed.

I N P U T
F I L T E R
A C T I O N S

Workflow

The Input Frame is use to select the Source/Control/Seed .ini file and to select which types of SelectCAD definitions to work against.

The purpose of the Filter Frame is to allow the selection of subsets from all the available definitions. For example, if department policy is to "update to standard" (clobber!) deviations in "Default," "Existing," "Proposed," and "Final Plot" definitions, Ini Manager allows Clobbering only those definitions, by selecting only these keywords.

Upon Clicking the "Process Source" command button, the "Available Keywords" list is populated. After the user selects one, many, or all Available Keywords, the Action Tabs are activated.

The Action Tabs provide access to functionality and information and generate results in the results window. Results can then be saved as a new civ*.ini file by hitting the "Save As" button.

Ini Manager can be used to Export/Import Feature Styles and Named Symbologies to/from spreadsheets.


ASCII Import

ASCII Import/Export

Ini Manager now allows the Export and Import of Named Symbology and Feature Styles to a comma-separated value (*.csv) text file. This format is easily (and with a little setup, automatically) opened into a spreadsheet for mass editing and QC. The Sorting and Filling functions, in particular, can really speed up managing Features and Symbologies.

Due to their variable structure Feature Filters and Preferences are not well suited for manipulation in spreadsheets and will not be supported (if you can provide me a reasonable workflow to mass manage them, I will be glad to incorporate it...).

One primary use I have targeted for this current, limited functionality is to assist in the management of Named Levels/Layers for MicroStation v8 and AutoCAD. The "LayerName" column in named symbologies is for the MicroStation v8/AutoCAD layer name; the "Level Number" column is for MicroStation v7- level numbers.. The InRoads Named Symbology GUI only shows one or the other. Other columns can be edited as desired.

Workflow

Note: Spreadsheets will allow you to make some big mistakes; I recommend that only Advanced Users/Hackers play around with these functions.

To Export to a Spreadsheet (*.csv) file:

  • Load a civil.ini. (the File Open dialog box now only opens *.ini's and *.csv's (note: only Ini Manager-formatted *.csv's will load properly))
  • Turn OFF the Feature Filters, and Preferences check boxes (Ini Manager will NOT import Feature Filters or Preferences).
  • Hit the Process button.
  • Filter the Feature Styles and Named Symbologies Keywords to be processed (put something in the "Selected Keywords" listbox).
  • On the Sorts and Exports tab, hit the "Export to Spreadsheet (*.csv)" button.
  • Hit the Save As... button on the Results form. Select a Type of "Spreadsheet-Ready (*.csv)".
  • Make your changes within the Spreadsheet.

To Import from a CSV file:

  • In the Input frame, key in or Browse to the proper (*.csv) file.
  • Hit the Process button.

At this point the data is converted from .csv format to .ini format. All "Ini Manager" operations can be performed normally.

The results can be saved as an *.ini file.

  • Select the Keywords to be targeted.
  • On the Sorts and Exports tab, hit the "Export to Ini (subset)" button.

Or use the "Compare 2 .ini's" function to update the Feature Styles and Named Symbologies in the (now obsolete) original file.


ASCII Import

ASCII Import/Export

Ini Manager now allows the Export and Import of Named Symbology and Feature Styles to a comma-separated value (*.csv) text file. This format is easily (and with a little setup, automatically) opened into a spreadsheet for mass editing and QC. The Sorting and Filling functions, in particular, can really speed up managing Features and Symbologies.

Due to their variable structure Feature Filters and Preferences are not well suited for manipulation in spreadsheets and will not be supported (if you can provide me a reasonable workflow to mass manage them, I will be glad to incorporate it...).

One primary use I have targeted for this current, limited functionality is to assist in the management of Named Levels/Layers for MicroStation v8 and AutoCAD. The "LayerName" column in named symbologies is for the MicroStation v8/AutoCAD layer name; the "Level Number" column is for MicroStation v7- level numbers.. The InRoads Named Symbology GUI only shows one or the other. Other columns can be edited as desired.

Workflow

Note: Spreadsheets will allow you to make some big mistakes; I recommend that only Advanced Users/Hackers play around with these functions.

To Export to a Spreadsheet (*.csv) file:

  • Load a civil.ini. (the File Open dialog box now only opens *.ini's and *.csv's (note: only Ini Manager-formatted *.csv's will load properly))
  • Turn OFF the Feature Filters, and Preferences check boxes (Ini Manager will NOT import Feature Filters or Preferences; exporting Preferences slows down the Import).
  • Hit the Process button.
  • Filter the Feature Styles and Named Symbologies Keywords to be processed (put something in the "Selected Keywords" listbox).
  • On the Sorts and Exports tab, hit the "Export to Spreadsheet (*.csv)" button.
  • Hit the Save As... button on the Results form. Select a Type of "Spreadsheet-Ready (*.csv)".
  • Make your changes within the Spreadsheet.

To Import from a CSV file:

  • In the Input frame, key in or Browse to the proper (*.csv) file.
  • Hit the Process button.

    The Input Frame

    The Input Frame is used to select the “Source” or “Control” file and to determine which types of SelectCAD definitions to process.

    The Source/Control/Seed .ini file or spreadsheet (.csv) file

    The “Source/Control/Seed” ini file is to be distinguished from the “Target/Victim/Update” file. In a distributed environment, the “Source/Control/Seed” file is that which conforms to standards and is the source for clobbering. For operations involving two ini files, the “Target/Victim/Update” file is the one that will be overwritten. ALL definitions in the Target file will get written to the results window, although some definitions may be clobber and other may be appended.

    The source file may also be a Comma Separated Value (*.csv) spreadsheet file that was previously exported from Ini Manager and modified. In the File Open dialog box, select the appropriate file type: Ini or CSV:

    When the Source/Control/Seed file is selected Ini Manager reads the header types and displays totals

    .

    The Action tabs are not enabled until at least one keyword is added to the "Target Keywords:" listbox.

    The Filter frame.

    The Filter frame is used to select subsets of headers to work on. The Action Tabs are not enabled until at least one keyword is added to the "Selected Keywords:" listbox.

    The “Add All,” “Add,” “Remove,” “Clear,” and the "Swap" command buttons should be fairly self-explanatory.

    The “Keywords Containing:” controls allow the user to select all headers with a given textstring. They can be used in conjuction with the other add/remove controls. An example might be to extract or overwrite definitions segregated by regulatory agency or municipality (e.g. “FDOT, SD”). To exclude keywords, use the Swap command after using the "Add ---^" command.

At this point the data is converted from .csv format to .ini format. All "Ini Manager" operations can be performed normally.

The results can be saved as an *.ini file.

  • Select the Keywords to be targeted.
  • On the Sorts and Exports tab, hit the "Export to Ini (subset)" button.

Or use the "Compare 2 .ini's" function to update the Feature Styles and Named Symbologies in the (now obsolete) original file.


The Input Frame is used to select the test or source file and to determine which types of files to

The Input Frame

The Input Frame is used to select the “Source” or “Control” file and to determine which types of SelectCAD definitions to process.

The Source/Control/Seed .ini file or spreadsheet (.csv) file

The “Source/Control/Seed” ini file is to be distinguished from the “Target/Victim/Update” file. In a distributed environment, the “Source/Control/Seed” file is that which conforms to standards and is the source for clobbering. For operations involving two ini files, the “Target/Victim/Update” file is the one that will be overwritten. ALL definitions in the Target file will get written to the results window, although some definitions may be clobber and other may be appended.

The source file may also be a Comma Separated Value (*.csv) spreadsheet file that was previously exported from Ini Manager and modified. In the File Open dialog box, select the appropriate file type: Ini or CSV:

When the Source/Control/Seed file is selected Ini Manager reads the header types and displays totals

.

The Action tabs are not enabled until at least one keyword is added to the "Target Keywords:" listbox.


The Input Frame is used to select the test or source file and to determine which types of files to

The Filter frame.

The Filter frame is used to select subsets of headers to work on. The Action Tabs are not enabled until at least one keyword is added to the "Selected Keywords:" listbox.

The “Add All,” “Add,” “Remove,” “Clear,” and the "Swap" command buttons should be fairly self-explanatory.

The “Keywords Containing:” controls allow the user to select all headers with a given textstring. They can be used in conjuction with the other add/remove controls. An example might be to extract or overwrite definitions segregated by regulatory agency or municipality (e.g. “FDOT, SD”). To exclude keywords, use the Swap command after using the "Add ---^" command.


The Input Frame is used to select the test or source file and to determine which types of files to

The Action Tabs.

Once at least one keyword has been selected as a Target, the Action Tabs are enabled.

Sort & Export exports the Headers matching the keywords to the Results window in either INI or CSV (spreadsheet format)..

Text Resizer provides the ability to provide consistent Text Heights, Widths and Linespacing.

Compare 2 ini's provides the ability to compare two .ini files and append and/or clobber selected Headers.


Extract

Sort & Exports

The Sort & Exports listview displays the full header name for all headers containing any of the Selected Keywords and the order in which they are found in the source .ini file. By clicking on the headers in the listview, the entries are sorted (or reversed) by that header. Data can be exported either in their current order in the source file or sorted alphabetically.

If, for some reason, you wanted to create an .ini file where the blocks are defined in reverse alphabetical order, then click the "All Headers Matching Target Keywords" header twice and then hit the "Export Matching Blocks" button.

"Export to Ini (subset)" exports the selected blocks to the Results window in INI format.

"Export to Spreadsheet (.csv) exports the data to a Comma-Separated Value file, which is easily imported into a spreadsheet for mass manipulation. Headers are included for the standard Named Symbology definitions.

Once manipulated the file can be Imported back into Ini Manager and saved in INI format.


Extract

Text Resizer

Text Resizer changes the Text Height, Text Width, and/or Line Spacing of blocks (typically Named Symbology) with headers matching any Target Keywords. SelectCAD places text according Text Height, Width and Line Spacing information defined in the .ini file MULTIPLIED by the Text Scale Factor found under Tools>Options>>Factors.

This is an example of why Action Tabs work on filtered Keywords. Very often organizations have a number of scale-based preferences, such as 10scale, 20metric, etc. Filtering on these preferences allow global text redefinition only within specific preferences.

Preview Resize

Preview Resize will show ALL the headers and any lines containing text size definitions. It shows the lines BEFORE the change so that you may verify before changes.

If, as in the case of the Kentucky Engineering Cabinet, your fields are separated by pipe ( | ) as opposed to the standard comma ( , ), check the checkbox in front of "Enable Handling "|" Delimited Text Definitions.


Extract

Compare 2 ini's

"Compare 2 ini's" requires the user to select a second ini file. This file is known as the victim file, because it gets clobbered. In a distributed environment this file represents the end-user's potentially-tainted file. Ini Manager makes it easy to "update to standard" (clobber) Preferences of specific themes (such as "Default", "existing", "final_plot", etc.).

EVERYTHING in the Test/Victim file gets passed to the Results windows. Blocks with deviating definitions can be updated/reset and all blocks only in the Control file can be optionally added to the Test/Victim file (choose the "Append All" option).

Upon getting a valid victim file, the listview lists Header names, "Location" and sequence found in the files. Totals are displayed under the listview.

Location is defined as follows

 | used when: | written to Results window?
Test.ini Only | Block exists only in Test/"Victim" File | Always
Control.ini Only | Block exists only in Control/Seed File | YES if "Append All" is selected
Both: Identical | Block exists in Both files, but are Identical | Always
Both Different | Header exists in Both files, definitions differ | YES if "Clobber All" is selected; MAYBE* if "Clobber Manually" is selected - *user decides

Append Mode: if set to "Append All", all blocks residing only in the Control/Seed file are appended to the Victim file.

Clobbering


Extract

Clobbering

Clobbering (overwriting a block definition) mode can be set to All Automatic, None, or Manual.

If set to "Clobber All" every block with Identical Headers but differing definitions is automatically overwritten (Control/Seed overwriting Victim/Test) upon hitting the "Clobber File" button.

If set to "Clobber None" the Victim File is untouched (blocks can still be Appended to the end of the file, if "Append All" is selected).

If "Clobber Manually" is selected, upon hitting the "Clobber File" button, Ini Manager sequentially processes blocks in the Victim file, invoking the Clobber (Preview) Form for each "Both: Different" block (duplicate block title, differing definitions).

Note: exit this form via the Close button; exiting using the kill button [image] causes a fatal error.

The user has the option of

  • "Clobbering This" block only,
  • "Skipping This" block only,
  • Skipping [this and] the Rest of the blocks
  • Clobbering [this and] the Rest of the blocks
  • exiting the form using the "Close" button.

Upon processing all the potential clobbers, the results are posted to the Results window.

Note: this is sometimes a lengthy process, don't immediately assume that the program has locked up.